IncludeFile "Screen3DRequester.pb"

Structure Vector3
  x.f
  y.f
  z.f
EndStructure

If InitEngine3D()
  
  InitSprite()
  InitKeyboard()
  InitMouse()
  InitSound()
  
  If Screen3DRequester()
    
    Add3DArchive("Media", #PB_3DArchive_FileSystem)
    Add3DArchive("Media/fonts", #PB_3DArchive_FileSystem)
    Add3DArchive("Media/materials/programs", #PB_3DArchive_FileSystem)
    Add3DArchive("Media/materials/scripts", #PB_3DArchive_FileSystem)
    Add3DArchive("Media/materials/textures", #PB_3DArchive_FileSystem)
    Add3DArchive("Media/particle", #PB_3DArchive_FileSystem)
    Add3DArchive("Media/packs/models.zip", #PB_3DArchive_Zip)    
    
    Parse3DScripts()
    
    LoadSound(0, "music.wav")
    PlaySound(0,  #PB_Sound_Loop)
    
    ;Set ambient light
    AmbientColor(RGB(255*0.5, 255*0.5,255*0.5))
    
    ;Create a light
    light = CreateLight(#PB_Any, RGB(255, 255, 255), 20, 80, 50)
    

    Mesh = LoadMesh(#PB_Any, "Plane01.mesh")
    ground = CreateEntity(#PB_Any, MeshID(Mesh), #PB_Material_None)
    
    For i=1 To 15
      fileMesh.s = "s" + Str(i) + ".mesh"
      Mesh = LoadMesh(#PB_Any, fileMesh)
      CreateEntity(#PB_Any, MeshID(Mesh), #PB_Material_None)
    Next
        
    
    Mesh = LoadMesh(#PB_Any, "cast1.mesh")
    cast1 = CreateEntity(#PB_Any, MeshID(Mesh), #PB_Material_None)	
    Mesh = LoadMesh(#PB_Any, "pilon.mesh")
    pilon = CreateEntity(#PB_Any, MeshID(Mesh), #PB_Material_None)	
        
    
    GetScriptParticleEmitter(#PB_Any, "PEExamples/stoneh2")
    pSys3 = GetScriptParticleEmitter(#PB_Any, "PEExamples/stoneh2_small")
    pSys4 = GetScriptParticleEmitter(#PB_Any, "PEExamples/stoneh2_small")
    pSys5 = GetScriptParticleEmitter(#PB_Any, "PEExamples/stoneh2_small")
    
    max2ogre.f=0.025
    Define.Vector3 triSpoutPos1, triSpoutPos2, triSpoutPos3
    
    triSpoutPos1\x = -0.084/max2ogre 
    triSpoutPos1\y =  0.354/max2ogre
    triSpoutPos1\z = -7.047/max2ogre
    
    triSpoutPos2\x =  5.872/max2ogre
    triSpoutPos2\y =  0.354/max2ogre
    triSpoutPos2\z =  3.461/max2ogre
    
    triSpoutPos3\x = -5.787/max2ogre
    triSpoutPos3\y =  0.354/max2ogre
    triSpoutPos3\z =  3.351/max2ogre
    
    
    spout_node1=CreateNode(#PB_Any, triSpoutPos1\x, triSpoutPos1\y, triSpoutPos1\z)
    spout_node2=CreateNode(#PB_Any, triSpoutPos2\x, triSpoutPos2\y, triSpoutPos2\z)
    spout_node3=CreateNode(#PB_Any, triSpoutPos3\x, triSpoutPos3\y, triSpoutPos3\z)
    
    
    AttachNodeObject(spout_node1, ParticleEmitterID(pSys3))
    AttachNodeObject(spout_node2, ParticleEmitterID(pSys4))
    AttachNodeObject(spout_node3, ParticleEmitterID(pSys5))
    
    cast1Mesh = LoadMesh(#PB_Any, "cast1.mesh")
    
    Cast3Mat = GetScriptMaterial(#PB_Any, "cast3")
    cast3 = CreateEntity(#PB_Any, MeshID(cast1Mesh), MaterialID(Cast3Mat), 0, 100, 0)
    ScaleEntity(cast3, 5,1,5)
    
    
    Cast4Mat = GetScriptMaterial(#PB_Any, "cast4")
    cast4 = CreateEntity(#PB_Any, MeshID(cast1Mesh), MaterialID(Cast4Mat), 0, 200, 0)
    ScaleEntity(cast4, 2,1,1)
    
    
    castTri1Mat = GetScriptMaterial(#PB_Any, "castTri")
    castTri1 = CreateEntity(#PB_Any, MeshID(cast1Mesh), MaterialID(castTri1Mat), triSpoutPos1\x, triSpoutPos1\y-10, triSpoutPos1\z)
    ScaleEntity(castTri1, 0.5,0.1,0.5)
    
    castTri2 = CreateEntity(#PB_Any, MeshID(cast1Mesh), MaterialID(castTri1Mat), triSpoutPos2\x, triSpoutPos2\y-10, triSpoutPos2\z)
    RotateEntity(castTri2, 0, -90, 0)
    ScaleEntity(castTri2, 0.5,0.1,0.5)
    
    castTri3 = CreateEntity(#PB_Any, MeshID(cast1Mesh), MaterialID(castTri1Mat), triSpoutPos3\x, triSpoutPos3\y-10, triSpoutPos3\z)
    RotateEntity(castTri3, 0, 90, 0)
    ScaleEntity(castTri3, 0.5,0.1,0.5)
    
    
    castsun1 = GetScriptMaterial(#PB_Any, "castsun1")
    castSun2 = CreateEntity(#PB_Any, MeshID(cast1Mesh), MaterialID(castsun1), 0, 10, 0)
    ScaleEntity(castSun2, 1.5, 0.1,1 .5)
    
    castsun = GetScriptMaterial(#PB_Any, "castsun")
    For sc=1 To 19
      castSun1 = CreateEntity(#PB_Any, MeshID(cast1Mesh), MaterialID(castsun), 0,40+sc*10,0)
      RotateEntity(castSun1, Random(5) , 0.5, Random(5))
      ScaleEntity(castSun1, 2.5-sc*0.05,0.1,2.5-sc*0.05)
    Next
    
    
    gorizontMesh = LoadMesh(#PB_Any , "gorizont.mesh")
    gorizont = CreateEntity(#PB_Any, MeshID(gorizontMesh), #PB_Material_None)
    barierMesh = LoadMesh(#PB_Any , "barier.mesh")
    barier = CreateEntity(#PB_Any, MeshID(barierMesh), #PB_Material_None)    
        

    
    
    ; create camera
    CamNode = CreateNode(#PB_Any, -244.852,392.682,-357.77)
    Camera = CreateCamera(#PB_Any, 0, 0, 100, 100)
    AttachNodeObject(CamNode, CameraID(Camera)) 
    
    ;-NodeAnimation
    CreateNodeAnimation(0, NodeID(CamNode), (319.382-28.307)*1000, #PB_NodeAnimation_Spline, #PB_NodeAnimation_SphericalRotation)
    
    fr=0;
    
    animDelay.f=1000.0
    timOffset.f=-28.8307*animDelay
        
    key = CreateNodeAnimationKeyFrame(0, animDelay*28.8307+timOffset, -244.852,392.682,-357.77)
    ;SetNodeAnimationKeyFrameRotation(0, key, pitch, yaw , roll) ; to do
    CreateNodeAnimationKeyFrame(0, animDelay*35.2817+timOffset, -393.737,294.394,-113.343)
    CreateNodeAnimationKeyFrame(0, animDelay*40.6439+timOffset, -422.293,349.852,173.018)
    CreateNodeAnimationKeyFrame(0, animDelay*49.6474+timOffset, -79.646 ,349.852,560.048)
    CreateNodeAnimationKeyFrame(0, animDelay*58.5187+timOffset, 501.429,267.73,432.065)
    CreateNodeAnimationKeyFrame(0, animDelay*67.7430+timOffset, 640.836,323.694,-73.3012)
    CreateNodeAnimationKeyFrame(0, animDelay*82.8461+timOffset, 169.581,523.395,-738.473)
    CreateNodeAnimationKeyFrame(0, animDelay*94.9738+timOffset, -544.202,335.46,-620.324)
    CreateNodeAnimationKeyFrame(0, animDelay*114.848+timOffset, -1279.63,1060.58,186.159)
    CreateNodeAnimationKeyFrame(0, animDelay*129.583+timOffset, -892.411,1131.63,999.012)
    CreateNodeAnimationKeyFrame(0, animDelay*141.035+timOffset, -404.345,716.693,1474.86)
    CreateNodeAnimationKeyFrame(0, animDelay*154.269+timOffset, 528.32,321.039,1093.36)
    CreateNodeAnimationKeyFrame(0, animDelay*167.148+timOffset, 245.522,66.4289,417.204)
    CreateNodeAnimationKeyFrame(0, animDelay*180.000+timOffset, 74.5456,161.762,229.612)
    CreateNodeAnimationKeyFrame(0, animDelay*200.000+timOffset, 99.7407,953.843,310.485)
    CreateNodeAnimationKeyFrame(0, animDelay*213.003+timOffset, 740.743,158.305,165.596)
    CreateNodeAnimationKeyFrame(0, animDelay*231.324+timOffset, 1889.01,281.073,89.9274)
    CreateNodeAnimationKeyFrame(0, animDelay*249.487+timOffset, 2872.93,118.85,-472.164)
    CreateNodeAnimationKeyFrame(0, animDelay*264.965+timOffset, 2613.98,169.808,-1362.87)
    CreateNodeAnimationKeyFrame(0, animDelay*278.284+timOffset, 2000.71,209.627,-1909.93)
    CreateNodeAnimationKeyFrame(0, animDelay*292.262+timOffset, 844.269,282.555,-1766.07)
    CreateNodeAnimationKeyFrame(0, animDelay*308.494+timOffset, 34.4144,291.87,-1023.65) 
    CreateNodeAnimationKeyFrame(0, animDelay*319.382+timOffset, -244.852,392.682,-357.77) 
    
    StartNodeAnimation(0)
    
    Repeat
      Screen3DEvents()
      
      ExamineKeyboard()
      
      AddNodeAnimationTime(0, TimeSinceLastFrame)
      CameraLookAt(Camera, 0, 0, 0)
      
      TimeSinceLastFrame = RenderWorld()
      
      Screen3DStats()
      FlipBuffers()
    Until KeyboardPushed(#PB_Key_Escape) Or Quit = 1
  EndIf
  
Else
  MessageRequester("Error", "The 3D Engine can't be initialized",0)
EndIf

End